#define SIZE 8      // dome matrix is SIZE x SIZE

#define BLACK     0
#define BLUE      1
#define GREEN     2
#define RED       3
#define YELLOW    4  
#define VIOLETT   5
#define TURQUOISE 6
#define WHITE     7

typedef uint8_t matrix_t[SIZE-1][SIZE];
typedef uint8_t led_t[8][3];
typedef struct {
    uint8_t pattern[8];         // touch pattern itself, connection groups
    uint8_t delta[4];           // unwanted delta shifts that generate an equal pattern
} pattern_t;


extern matrix_t matrix;                         // sensor input matrix
extern matrix_t pattern;                        // setpoint touch pattern
extern uint8_t  matrix_cal[SIZE];               // sensor calibration
extern led_t    leds;                           // LEDs

/*

This ist the matrix for the scan und set pattern
only the upper half is used, the rest is always empty and never used

matrix_t matrix[r][c];

   c 0   1   2   3   4   5   6   7
r
0:       0   0   0   0   0   0   0
1:           0   0   0   0   0   0
2:               0   0   0   0   0
3:                   0   0   0   0
4:                       0   0   0
5:                           0   0
6:                               0

*/

extern const uint8_t colors[8][3] PROGMEM;          // colors for domes
extern const uint8_t color_circle[6][4] PROGMEM;    // colors for ligth show
extern const pattern_t patterns[6] PROGMEM;         // touch patterns
extern const uint8_t levels[3][20][3] PROGMEM;      // level programm
extern const uint8_t menu_select_difficulty[8] PROGMEM; // colors for difficulty selection
extern const uint8_t menu_all_colors[8] PROGMEM;        // test all colors

extern volatile uint8_t flag_100ms;              // itself
extern uint8_t enable_light_show;                // itself, light show runs at 100Hz main loop for smoother operation
